﻿<?php

define('DB_NAME', 'Jmeno databaze');
define('DB_USER', 'Jmeno uzivatele');
define('DB_PASSWORD', 'Heslo k databazi');
define('DB_HOST', 'databazovy server');
define('TABLE_PREFIX', 'wp_');

define('CF7_NAME', 'your-name');
define('CF7_PHONE', 'your-phone');
define('COUNTRY_CODE', '+420');

define('FILENAME', 'export');

define("SERVER", "https://admin.smsvio.cz");
define("API_KEY", "vas API key z administrace");
define("DEVICE_ID", 0);

define("UNSUBSCRIBE_FILE", __DIR__ . "/unsubscribed.json");

function sendSingleMessage($number, $message, $device = 0)
{
    $url = SERVER . "/services/send.php";
    $postData = array('number' => $number, 'message' => $message, 'key' => API_KEY, 'devices' => $device);
    return sendRequest($url, $postData)["messages"][0];
}

function sendRequest($url, $postData)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postData));
    $response = curl_exec($ch);
    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    if (curl_errno($ch)) {
        throw new Exception(curl_error($ch));
    }
    curl_close($ch);
    if ($httpCode == 200) {
        $json = json_decode($response, true);
        if ($json == false) {
            if (empty($response)) {
                throw new Exception("Missing data in request. Please provide all the required information to send messages.");
            } else {
                throw new Exception($response);
            }
        } else {
            if ($json["success"]) {
                return $json["data"];
            } else {
                throw new Exception($json["error"]["message"]);
            }
        }
    } else {
        throw new Exception("HTTP Error Code : {$httpCode}");
    }
}

$con = mysqli_connect(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);

if (mysqli_connect_errno()) {
    echo "Failed to connect to MySQL: " . mysqli_connect_error();
} else {
    try {
        if (isset($_SERVER["HTTP_X_SG_SIGNATURE"])) {
            $hash = base64_encode(hash_hmac('sha256', $_POST["messages"], API_KEY, true));
            if ($hash === $_SERVER["HTTP_X_SG_SIGNATURE"]) {
                $messages = json_decode($_POST["messages"], true);

                foreach ($messages as $message) {
                    $phone = substr($message["number"], 0, 1) === "+" ? substr($message["number"], strlen(COUNTRY_CODE)) : $message["number"];
                    if (strtolower($message["message"]) === "odhlásit" || strtolower($message["message"]) === "odhlasit") {
                        $result = mysqli_query($con, "SELECT * FROM " . TABLE_PREFIX . "cf7_vdata_entry WHERE name='" . CF7_PHONE . "' AND (value='" . $message["number"] . "' OR value='" . substr($message["number"], strlen(COUNTRY_CODE)) . "')");

                        if (!$result) {
                            throw new Exception("Could not successfully run query from DB: " . mysqli_error($con));
                        } else {
                            mysqli_begin_transaction($con);
                            while ($row = mysqli_fetch_assoc($result)) {
                                $success = mysqli_query($con, "DELETE FROM " . TABLE_PREFIX . "cf7_vdata WHERE id=" . $row["data_id"]);
                                if ($success) {
                                    mysqli_query($con, "DELETE FROM " . TABLE_PREFIX . "cf7_vdata_entry WHERE data_id=" . $row["data_id"]);
                                }

                                if (!empty(mysqli_error($con))) {
                                    throw new Exception("Could not successfully run query from DB: " . mysqli_error($con));
                                }
                            }
                            mysqli_commit($con);
                            sendSingleMessage($message["number"], "Vaše telefonní číslo bylo z odběru odhlášeno.", DEVICE_ID);
                        }
                    } else if (strtolower($message["message"]) === "odhlásit se" || strtolower($message["message"]) === "odhlasit se") {
                        $unsubscribed = [];
                        if (file_exists(UNSUBSCRIBE_FILE)) {
                            $unsubscribed = json_decode(file_get_contents(UNSUBSCRIBE_FILE), true);
                        }
                        if (!isset($unsubscribed[$phone])) {
                            $unsubscribed[$phone] = time();
                            file_put_contents(UNSUBSCRIBE_FILE, json_encode($unsubscribed));
                            sendSingleMessage($message["number"], "Vaše telefonní číslo bylo z odběru odhlášeno. Pokud se v budoucnu rozhodnete znovu k odběru zpráv přihlásit, odešlete zprávu 'Znovu přihlásit'.", DEVICE_ID);
                        }
                    } else if (strtolower($message["message"]) === "znovu přihlásit" || strtolower($message["message"]) === "znovu prihlasit") {
                        if (file_exists(UNSUBSCRIBE_FILE)) {
                            $unsubscribed = json_decode(file_get_contents(UNSUBSCRIBE_FILE), true);
                            if (isset($unsubscribed[$phone])) {
                                unset($unsubscribed[$phone]);
                                file_put_contents(UNSUBSCRIBE_FILE, json_encode($unsubscribed));
                                sendSingleMessage($message["number"], "K odběru zpráv jste byli znovu prihlášeni.", DEVICE_ID);
                            }
                        }
                    }
                }

            } else {
                http_response_code(401);
                throw new Exception("Signature don't match!");
            }
        } else if (isset($_GET["type"]) && $_GET["type"] === "woocommerce") {
            $result = mysqli_query($con, "SELECT * FROM " . TABLE_PREFIX . "woocommerce_order_items as odr LEFT JOIN " . TABLE_PREFIX . "postmeta as pm ON odr.order_id = pm.post_id");
            if (!$result) {
                echo "Could not successfully run query from DB: " . mysqli_error($con);
                exit;
            }

            if (mysqli_num_rows($result) == 0) {
                echo "No rows found, nothing to print so I am exiting.";
                exit;
            }

            $subscribers = [];
            while ($row = mysqli_fetch_assoc($result)) {
                if(!isset($subscribers[$row["post_id"]])) {
                    $subscribers[$row["post_id"]] = [];
                }
                if($row["meta_key"] === "_billing_phone") {
                    $subscribers[$row["post_id"]]["phone"] = $row["meta_value"];
                }
                else if($row["meta_key"] === "_billing_first_name") {
                    $subscribers[$row["post_id"]]["fName"] = $row["meta_value"];
                } else if($row["meta_key"] === "_billing_last_name") {
                    $subscribers[$row["post_id"]]["lName"] = $row["meta_value"];
                }
            }

            ob_start();
            $file = fopen('php://output', 'w');
            $unsubscribed = [];
            if (file_exists(UNSUBSCRIBE_FILE)) {
                $unsubscribed = json_decode(file_get_contents(UNSUBSCRIBE_FILE), true);
            }

            $numbers = [];
            foreach ($subscribers as $subscriber) {
                if(!in_array($subscriber["phone"], $numbers) && !isset($unsubscribed[$subscriber["phone"]])) {
                    fputcsv($file, [$subscriber["phone"], $subscriber["fName"] . " " . $subscriber["lName"]]);
                    $numbers[] = $subscriber["phone"];
                }
            }

            header('Content-Type: text/csv; charset=ISO-8859-2');
            header('Content-Disposition: attachment; filename="' . FILENAME . '.csv"');
            echo ob_get_clean();
        } else {
            $result = mysqli_query($con, "SELECT * FROM " . TABLE_PREFIX . "cf7_vdata as vdata LEFT JOIN " . TABLE_PREFIX . "cf7_vdata_entry as entry ON vdata.id = entry.data_id");
            if (!$result) {
                echo "Could not successfully run query from DB: " . mysqli_error($con);
                exit;
            }

            if (mysqli_num_rows($result) == 0) {
                echo "No rows found, nothing to print so I am exiting.";
                exit;
            }

            $subscribers = [];
            while ($row = mysqli_fetch_assoc($result)) {
                if (!isset($subscribers[$row["data_id"]])) {
                    $subscribers[$row["data_id"]] = [];
                }
                if ($row["name"] === CF7_NAME) {
                    $subscribers[$row["data_id"]]["name"] = $row["value"];
                }
                if ($row["name"] === CF7_PHONE) {
                    $subscribers[$row["data_id"]]["phone"] = $row["value"];
                }
            }

            ob_start();
            $file = fopen('php://output', 'w');

            $numbers = [];
            foreach ($subscribers as $subscriber) {
                if (!in_array($subscriber["phone"], $numbers)) {
                    fputcsv($file, [$subscriber["phone"], $subscriber["name"]]);
                    $numbers[] = $subscriber["phone"];
                }
            }

            header('Content-Type: text/csv; charset=ISO-8859-2');
            header('Content-Disposition: attachment; filename="' . FILENAME . '.csv"');
            echo ob_get_clean();
        }
    } catch (Exception $e) {
        error_log($e->getMessage());
    }

    if (isset($result)) {
        mysqli_free_result($result);
    }
    mysqli_close($con);
}